eal/memory: fix unused SIGBUS handler
[dpdk.git] / devtools / check-abi.sh
index dd9120e..ca523eb 100755 (executable)
@@ -3,7 +3,7 @@
 # Copyright (c) 2019 Red Hat, Inc.
 
 if [ $# != 2 ] && [ $# != 3 ]; then
-       echo "Usage: $0 refdir newdir [warnonly]"
+       echo "Usage: $0 refdir newdir [warnonly]" >&2
        exit 1
 fi
 
@@ -13,23 +13,23 @@ warnonly=${3:-}
 ABIDIFF_OPTIONS="--suppr $(dirname $0)/libabigail.abignore --no-added-syms"
 
 if [ ! -d $refdir ]; then
-       echo "Error: reference directory '$refdir' does not exist."
+       echo "Error: reference directory '$refdir' does not exist." >&2
        exit 1
 fi
 incdir=$(find $refdir -type d -a -name include)
 if [ -z "$incdir" ] || [ ! -e "$incdir" ]; then
-       echo "WARNING: could not identify a include directory for $refdir, expect false positives..."
+       echo "WARNING: could not identify an include directory for $refdir, expect false positives..." >&2
 else
        ABIDIFF_OPTIONS="$ABIDIFF_OPTIONS --headers-dir1 $incdir"
 fi
 
 if [ ! -d $newdir ]; then
-       echo "Error: directory to check '$newdir' does not exist."
+       echo "Error: directory to check '$newdir' does not exist." >&2
        exit 1
 fi
 incdir2=$(find $newdir -type d -a -name include)
 if [ -z "$incdir2" ] || [ ! -e "$incdir2" ]; then
-       echo "WARNING: could not identify a include directory for $newdir, expect false positives..."
+       echo "WARNING: could not identify an include directory for $newdir, expect false positives..." >&2
 else
        ABIDIFF_OPTIONS="$ABIDIFF_OPTIONS --headers-dir2 $incdir2"
 fi
@@ -44,21 +44,32 @@ for dump in $(find $refdir -name "*.dump"); do
                echo "Skipped glue library $name."
                continue
        fi
-       # skip experimental libraries, with a sover starting with 0.
-       if grep -qE "\<soname='[^']*\.so\.0\.[^']*'" $dump; then
-               echo "Skipped experimental library $name."
+       if grep -qE "\<soname='librte_event_dlb\.so" $dump; then
+               echo "Skipped removed driver $name."
                continue
        fi
        dump2=$(find $newdir -name $name)
        if [ -z "$dump2" ] || [ ! -e "$dump2" ]; then
-               echo "Error: can't find $name in $newdir"
+               echo "Error: cannot find $name in $newdir" >&2
                error=1
                continue
        fi
-       if ! abidiff $ABIDIFF_OPTIONS $dump $dump2; then
-               echo "Error: ABI issue reported for 'abidiff $ABIDIFF_OPTIONS $dump $dump2'"
+       abidiff $ABIDIFF_OPTIONS $dump $dump2 || {
+               abiret=$?
+               echo "Error: ABI issue reported for 'abidiff $ABIDIFF_OPTIONS $dump $dump2'" >&2
                error=1
-       fi
+               echo
+               if [ $(($abiret & 3)) -ne 0 ]; then
+                       echo "ABIDIFF_ERROR|ABIDIFF_USAGE_ERROR, this could be a script or environment issue." >&2
+               fi
+               if [ $(($abiret & 4)) -ne 0 ]; then
+                       echo "ABIDIFF_ABI_CHANGE, this change requires a review (abidiff flagged this as a potential issue)." >&2
+               fi
+               if [ $(($abiret & 8)) -ne 0 ]; then
+                       echo "ABIDIFF_ABI_INCOMPATIBLE_CHANGE, this change breaks the ABI." >&2
+               fi
+               echo
+       }
 done
 
 [ -z "$error" ] || [ -n "$warnonly" ]